;programmed by Patrick McLaughlin
;started 1/24/99
;last modified 2/2/99
#include "usgard.h"
.org 0
.db "by Patrick McLaughlin",0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
prevpos = TEXT_MEM+2
prevpiece = TEXT_MEM+4
prevb = TEXT_MEM+6
prevc = TEXT_MEM+8
selectedpos = TEXT_MEM+10
selectedpiece = TEXT_MEM+12
selectedb = TEXT_MEM+14
selectedc = TEXT_MEM+16
selectedcolorofspace = TEXT_MEM+18
colorofspace = TEXT_MEM+20
whosturn = TEXT_MEM+22
pawnfirstmove = TEXT_MEM+24
posofwarook = TEXT_MEM+26
posofwhrook = TEXT_MEM+28
posofwking = TEXT_MEM+30
posofbarook = TEXT_MEM+32
posofbhrook = TEXT_MEM+34
posofbking = TEXT_MEM+36
enpassentwhite = TEXT_MEM+38
enpassentblack = TEXT_MEM+40
intendedpos = TEXT_MEM+42
enpassentcolor = TEXT_MEM+44
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	call CLEARLCD
	ld a,0
	ld (prevpiece),a
	ld (colorofspace),a
	ld (whosturn),a
	ld (posofwarook),a
	ld (posofwhrook),a
	ld (posofwking),a
	ld (posofbarook),a
	ld (posofbhrook),a
	ld (posofbking),a
	ld (enpassentwhite),a
	ld (enpassentblack),a
	ld a,32
	ld (prevb),a
	ld a,35
	ld (prevc),a
	inc a
	ld (prevpos),a
	ld a,255
	ld (selectedpiece),a

	ld hl,&openingchess
	ld b,8
	call &puttext	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
initialloop:
	ld a,$BF
	call READ_KEYPAD
	bit 6,a
	call z,OTH_EXIT
	bit 5,a
	jr z,ldnewboard
	bit 4,a
	jr z,ldsavedboard
	jr initialloop
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ldsavedboard:
	ld hl,&savedwhosturn
	ld a,(hl)
	ld (whosturn),a
	inc hl
	ld de,&currentboard		;reset the board
	ld bc,64
	ldir
	jr putselected
ldnewboard:
	ld hl,&startboard		;reset the board
	ld de,&currentboard
	ld bc,64
	ldir
putselected:
	call CLEARLCD
	ld hl,&selected			;put selected:
	ld b,1
	call &puttext
	ld b,0
	ld c,7
	ld de,&currentboard
createboard:
	push de
	ld a,(de)
	ld (TEXT_MEM),a
	ld de,(TEXT_MEM)
	ld hl,&pieces
	add hl,de
	pop de
	call &PutSprite
	inc de
	ld a,b
	cp 56
	jr z,nextrank
	ld a,8
	add a,b
	ld b,a
	jr createboard
nextrank:
	ld b,0
	ld a,c
	cp 56
	jr z,border
	ld a,7
	add a,c
	ld c,a
	jr createboard
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
border:
	ld hl,$FC78
	ld de,16
	ld b,57
border1:
	ld (hl),%10000000
	add hl,de
	djnz border1
	ld hl,$FFF0
	ld b,8
border2:
	ld (hl),%11111111
	inc hl
	djnz border2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	ld b,32
	ld c,35
	ld hl,&currentboard
	ld de,(prevpos)
	add hl,de
	ld a,(hl)
	ld (prevpiece),a
	ld hl,&pieces
	ld de,112
	add hl,de
	call &PutSprite2
mainloop:
	call OTH_ARROW
	bit 6,a
	call z,OTH_EXIT
	bit 7,a
	jp z,&saveboard
	bit 0,a
	jp z,&down
	bit 1,a
	jp z,&left
	bit 2,a
	jp z,&right
	bit 3,a
	jp z,&up
	bit 5,a
	jp z,&select
	jp &mainloop
aftermove:
	call &putcursor
	call &delay
	ld a,(colorofspace)
	add a,8
	cp 16
	jr z,ldawith0
	ld (colorofspace),a
	jp &mainloop
ldawith0:
	ld a,0
	ld (colorofspace),a
	jp &mainloop
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
down:
	ld a,c
	cp 56
	jp z,&mainloop
	ld de,8
	add a,7
	ld c,a
	jp &aftermove
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
left:
	ld a,b
	or a
	jp z,&mainloop
	ld de,-1
	sub 8
	ld b,a
	jp &aftermove
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
right:
	ld a,b
	cp 56
	jp z,&mainloop
	ld de,1
	add a,8
	ld b,a
	jp &aftermove
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
up:
	ld a,c
	cp 7
	jp z,&mainloop
	ld de,-8
	sub 7
	ld c,a
	jp &aftermove
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
select:
	ld a,(prevpiece)		;is there a piece there
	cp 9
	jp c,&isa255			;no
aisapiece:				;store data of selected piece
	ld a,(selectedpiece)		;do we already have the data
	cp 112
	jr c,testforblock		;yes
	ld a,(whosturn)			;is the selected piece the right color
	or a
	jp z,&aiswhite
aisblack:
	ld a,(prevpiece)
	cp 57
	jp nc,&selectedpieceisrightcolortomove
	jp &mainloop			;no
aiswhite:
	ld a,(prevpiece)
	cp 57
	jp nc,&mainloop			;no


selectedpieceisrightcolortomove:
	ld a,(prevpiece)		;store the data
	ld (selectedpiece),a
	ld a,(prevpos)
	ld (selectedpos),a
	ld a,(prevb)
	ld (selectedb),a
	ld a,(prevc)
	ld (selectedc),a
	ld a,(colorofspace)
	ld (selectedcolorofspace),a
	push bc				;put selected piece on screen
	ld b,31
	ld c,0
	ld hl,&pieces
	ld de,(selectedpiece)
	add hl,de
	call &PutSprite
	ld hl,$FC04
	ld (hl),%00000000
	ld hl,$FC03
	ld de,16
	ld b,7
eraseside:				;erase some excess stuff on screen
	ld (hl),%00000000
	add hl,de
	djnz eraseside
	ld hl,&selected
	ld b,1
	call &puttext
	pop bc
	jp &mainloop


testforblock:
	ld hl,&currentboard		;is a same color piece blocking you
	ld de,(prevpos)
	add hl,de
	ld a,(hl)
	push af
	ld a,(whosturn)
	or a
	jr z,testsamecolorwhite
testsamecolorblack:
	pop af
	cp 57
	jp nc,&selectedpieceisrightcolortomove
	jr testcoordinates
testsamecolorwhite:
	pop af
	cp 9
	jr c,testcoordinates
	cp 57
	jp c,&selectedpieceisrightcolortomove


testcoordinates:
	ld a,(selectedpiece)		;is it a legal move
	cp 16
	jp z,&testpawnmovementwhite
	cp 24
	jp z,&testknightmovement
	cp 32
	jp z,&testbishopmovement
	cp 40
	jp z,&testrookmovement
	cp 48
	jp z,&testqueenmovement
	cp 56
	jp z,&testkingmovement
	cp 64
	jp z,&testpawnmovementblack
	cp 72
	jp z,&testknightmovement
	cp 80
	jp z,&testbishopmovement
	cp 88
	jp z,&testrookmovement
	cp 96
	jp z,&testqueenmovement
	cp 104
	jp z,&testkingmovement


movepiece:				;test, move, put, and store piece
	push bc
	ld a,(selectedb)
	ld b,a
	ld a,(selectedc)
	ld c,a
	ld hl,&currentboard
	ld de,(selectedpos)
	add hl,de
	ld a,(selectedcolorofspace)
	ld (hl),a
	ld hl,&pieces
	ld de,(selectedcolorofspace)
	add hl,de
	call &PutSprite
	pop bc
	ld hl,&currentboard
	ld de,(prevpos)
	add hl,de
	ld a,(selectedpiece)
	ld (prevpiece),a
	ld (hl),a
	ld hl,&pieces
	ld de,(selectedpiece)
	add hl,de
	call &PutSprite
	push bc
	ld hl,$FC04
	ld de,16
	ld b,7
erasepiece:				;erase selected piece at top
	ld (hl),%00000000
	add hl,de
	djnz erasepiece
	pop bc
	ld a,(whosturn)			;change turn to other color
	inc a
	cp 2
	jr nz,ais1
	ld a,0
ais1:
	ld (whosturn),a
	cp 1
	jr z,checkforwhitecastle
	or a
	jr z,checkforblackcastle
resetselectionprocess:
	ld a,255			;reset selection process
	ld (selectedpiece),a
	jp &mainloop

checkforwhitecastle:
	ld a,(posofwking)
	cp 1
	jp z,&movewhiterookkingside
	cp 2
	jp z,&movewhiterookqueenside
	jr resetselectionprocess

checkforblackcastle:
	ld a,(posofbking)
	cp 1
	jp z,&moveblackrookkingside
	cp 2
	jp z,&moveblackrookqueenside
	jr resetselectionprocess

isa255:
	ld a,(selectedpiece)		;make sure there's no piece there
	cp 255
	jp nz,&testforblock		;there is a piece
	jp &mainloop			;nope, no piece
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
putcursor:
	push de
	push bc
	ld a,(prevb)
	ld b,a
	ld a,(prevc)
	ld c,a
	ld de,(prevpiece)
	ld hl,&pieces
	add hl,de
	call &PutSprite
	pop bc
	ld hl,&pieces
	ld de,112
	add hl,de
	call &PutSprite2
	pop de
	ld hl,(prevpos)
	add hl,de
	ld (prevpos),hl
	ex de,hl
	ld hl,&currentboard
	add hl,de
	ld a,(hl)
	ld (prevpiece),a
	ld a,b
	ld (prevb),a
	ld a,c
	ld (prevc),a
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
testpawnmovementwhite:
	ld a,(selectedb)		;make sure movement is legal
	sub b
	jr z,notatake			;pawn isn't taking anything
	jr nc,dontmakepositive		;pawn might be trying to take something
	neg
dontmakepositive:
	ld d,a
	ld a,(selectedc)		;maybe
	sub c
	add a,d
	cp 15
	jp nz,&mainloop			;no
	ld a,(prevpiece)
	cp 9
	jp c,&isittryinganenpassent1	;no
	cp 57
	jr nc,checkforpromotion		;yes
	jp &mainloop			;no

notatake:
	call &testforblockingpieces
	or a
	jp nz,&mainloop
	ld a,(selectedc)
	sub c
	cp 7
	jr z,checkforpromotion
	cp 14				;is it a two space first move
	jp nz,&mainloop
	ld a,(selectedc)
	cp 49
	jp z,&checkforenablingenpassent
	jp &mainloop

checkforpromotion:
	ld a,c
	cp 7
	jp nz,&movepiece
	push bc
	ld hl,&promotion
	ld b,1
	call &puttext
	
checkforletter:
	ld a,$DF
	call READ_KEYPAD
	bit 3,a
	jr z,knightisselected
	ld a,$EF
	call READ_KEYPAD
	bit 5,a
	jr z,bishopisselected
	bit 2,a
	jr z,queenisselected
	ld a,$F7
	call READ_KEYPAD
	bit 2,a
	jr z,rookisselected
	jr checkforletter

knightisselected:
	ld a,24
	ld (selectedpiece),a
	jr storeintocurrentboard
bishopisselected:
	ld a,32
	ld (selectedpiece),a
	jr storeintocurrentboard
queenisselected:
	ld a,48
	ld (selectedpiece),a
	jr storeintocurrentboard
rookisselected:
	ld a,40
	ld (selectedpiece),a
	jr storeintocurrentboard

storeintocurrentboard:
	pop bc
	ld hl,&currentboard
	ld de,(prevpos)
	add hl,de
	ld (hl),a
	ld e,5
	call &eraseinstructions
	jp &movepiece

isittryinganenpassent1:
	ld a,(selectedb)
	sub b
	ld d,a
	ld a,(enpassentwhite)
	cp 1
	jr z,checkforenpassentwhite1
	cp 2
	jp nz,&mainloop
checkforenpassentwhite2:
	ld a,d
	cp -8
	jr z,moveenpassent4
	jp &mainloop
checkforenpassentwhite1:
	ld a,d
	cp 8
	jp nz,&mainloop

moveenpassent3:
	ld a,(selectedcolorofspace)
	add a,8
	cp 16
	jr nz,ais83
	ld a,0
ais83:
	ld hl,&currentboard
	ld de,(selectedpos)
	dec de
	add hl,de
	ld (hl),a
	ld (enpassentcolor),a
	ld de,(enpassentcolor)
	push bc
	ld a,(selectedb)
	sub 8
	ld b,a
	ld a,(selectedc)
	ld c,a
	ld hl,&pieces
	add hl,de
	call &PutSprite
	pop bc
	ld a,0
	ld (enpassentwhite),a
	jp &movepiece

moveenpassent4:
	ld a,(selectedcolorofspace)
	add a,8
	cp 16
	jr nz,ais84
	ld a,0
ais84:
	ld hl,&currentboard
	ld de,(selectedpos)
	inc de
	add hl,de
	ld (hl),a
	ld (enpassentcolor),a
	ld de,(enpassentcolor)
	push bc
	ld a,(selectedb)
	add a,8
	ld b,a
	ld a,(selectedc)
	ld c,a
	ld hl,&pieces
	add hl,de
	call &PutSprite
	pop bc
	ld a,0
	ld (enpassentwhite),a
	jp &movepiece

checkforenablingenpassent:
	ld hl,&currentboard
	ld de,(prevpos)
	inc de
	add hl,de
	ld a,(hl)
	cp 64
	jr z,enableenpassentblack1
	dec hl
	dec hl
	ld a,(hl)
	cp 64
	jp nz,&movepiece
enableenpassentblack2:
	ld a,2
	ld (enpassentblack),a
	jp &movepiece
enableenpassentblack1:
	ld a,1
	ld (enpassentblack),a
	jp &movepiece
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
testpawnmovementblack:
	ld a,(selectedb)		;make sure movement is legal
	sub b
	jr z,notatake1			;pawn isn't taking anything
	jr nc,dontmakepositive1		;pawn might be trying to take something
	neg
dontmakepositive1:
	ld d,a
	ld a,(selectedc)		;maybe
	sub c
	add a,d
	cp 1
	jp nz,&mainloop			;no
	ld a,(prevpiece)
	cp 9
	jp c,&isittryinganenpassent	;no
	cp 57
	jp c,&checkforpromotion1	;yes
	jp &mainloop			;no

notatake1:
	call &testforblockingpieces
	or a
	jp nz,&mainloop
	ld a,(selectedc)
	sub c
	cp -7
	jp z,&checkforpromotion1
	cp -14				;is it a two space first move
	jp nz,&mainloop
	ld a,(selectedc)
	cp 14
	jp z,&checkforenablingenpassent1
	jp &mainloop

checkforpromotion1:
	ld a,c
	cp 56
	jp nz,&movepiece
	push bc
	ld hl,&promotion
	ld b,1
	call &puttext
	
checkforletter1:
	ld a,$DF
	call READ_KEYPAD
	bit 3,a
	jr z,knightisselected1
	ld a,$EF
	call READ_KEYPAD
	bit 5,a
	jr z,bishopisselected1
	bit 2,a
	jr z,queenisselected1
	ld a,$F7
	call READ_KEYPAD
	bit 2,a
	jr z,rookisselected1
	jr checkforletter1

knightisselected1:
	ld a,72
	ld (selectedpiece),a
	jr storeintocurrentboard1
bishopisselected1:
	ld a,80
	ld (selectedpiece),a
	jr storeintocurrentboard1
queenisselected1:
	ld a,96
	ld (selectedpiece),a
	jr storeintocurrentboard1
rookisselected1:
	ld a,88
	ld (selectedpiece),a
	jr storeintocurrentboard1

storeintocurrentboard1:
	pop bc
	ld hl,&currentboard
	ld de,(prevpos)
	add hl,de
	ld (hl),a
	ld e,5
	call &eraseinstructions

isittryinganenpassent:
	ld a,(selectedb)
	sub b
	ld d,a
	ld a,(enpassentblack)
	cp 1
	jr z,checkforenpassentblack1
	cp 2
	jp nz,&mainloop
checkforenpassentblack2:
	ld a,d
	cp -8
	jr z,moveenpassent2
	jp &mainloop
checkforenpassentblack1:
	ld a,d
	cp 8
	jp nz,&mainloop

moveenpassent1:
	ld a,(selectedcolorofspace)
	add a,8
	cp 16
	jr nz,ais81
	ld a,0
ais81:
	ld hl,&currentboard
	ld de,(selectedpos)
	dec de
	add hl,de
	ld (hl),a
	ld (enpassentcolor),a
	ld de,(enpassentcolor)
	push bc
	ld a,(selectedb)
	sub 8
	ld b,a
	ld a,(selectedc)
	ld c,a
	ld hl,&pieces
	add hl,de
	call &PutSprite
	pop bc
	ld a,0
	ld (enpassentblack),a
	jp &movepiece

moveenpassent2:
	ld a,(selectedcolorofspace)
	add a,8
	cp 16
	jr nz,ais82
	ld a,0
ais82:
	ld hl,&currentboard
	ld de,(selectedpos)
	inc de
	add hl,de
	ld (hl),a
	ld (enpassentcolor),a
	ld de,(enpassentcolor)
	push bc
	ld a,(selectedb)
	add a,8
	ld b,a
	ld a,(selectedc)
	ld c,a
	ld hl,&pieces
	add hl,de
	call &PutSprite
	pop bc
	ld a,0
	ld (enpassentblack),a
	jp &movepiece

checkforenablingenpassent1:
	ld hl,&currentboard
	ld de,(prevpos)
	inc de
	add hl,de
	ld a,(hl)
	cp 16
	jr z,enableenpassentwhite1
	dec hl
	dec hl
	ld a,(hl)
	cp 16
	jp nz,&movepiece
enableenpassentwhite2:
	ld a,2
	ld (enpassentwhite),a
	jp &movepiece
enableenpassentwhite1:
	ld a,1
	ld (enpassentwhite),a
	jp &movepiece
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
testknightmovement:
	ld a,(selectedb)		;make sure movement is legal
	sub b
	jr nc,aispositive
	neg
aispositive:
	ld d,a
	ld a,(selectedc)
	sub c
	jr nc,aispositive1
	neg
aispositive1:
	add a,d
	cp 22
	jp z,&movepiece
	cp 23
	jp z,&movepiece
	jp &mainloop
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
testbishopmovement:
	call &testforblockingpieces	;make sure movement is legal
	or a
	jp nz,&mainloop
	ld a,(selectedb)
	sub b
	jr nc,aispositive2
	neg
aispositive2:
	ld d,a
	ld a,(selectedc)
	sub c
	jr nc,aispositive3
	neg
aispositive3:
	add a,d
	cp 15
	jp z,&movepiece
	cp 30
	jp z,&movepiece
	cp 45
	jp z,&movepiece
	cp 60
	jp z,&movepiece
	cp 75
	jp z,&movepiece
	cp 90
	jp z,&movepiece
	cp 105
	jp z,&movepiece
	jp &mainloop
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
testrookmovement:
	call &testforblockingpieces	;make sure movement is legal
	or a
	jp nz,&mainloop
	ld a,(selectedb)
	sub b
	jr z,disablecastleofrookandking
	ld a,(selectedc)
	sub c
	jp nz,&mainloop
disablecastleofrookandking:
	ld a,(selectedb)
	ld d,a
	ld a,(selectedc)
	add a,d
	cp 7
	jr z,disableposofbarook
	cp 56
	jr z,disableposofwarook
	cp 63
	jr z,disableposofbhrook
disableposofwhrook:
	ld a,255
	ld (posofwhrook),a
	jp &movepiece
disableposofbarook:
	ld a,255
	ld (posofbarook),a
	jp &movepiece
disableposofwarook:
	ld a,255
	ld (posofwarook),a
	jp &movepiece
disableposofbhrook:
	ld a,255
	ld (posofbhrook),a
	jp &movepiece
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
testqueenmovement:
	call &testforblockingpieces	;make sure movement is legal
	or a
	jp nz,&mainloop
	ld a,(selectedb)
	sub b
	jr nc,aispositive4
	neg
aispositive4:
	ld d,a
	ld a,(selectedc)
	sub c
	jr nc,aispositive5
	neg
aispositive5:
	add a,d
	cp 15
	jp z,&movepiece
	cp 30
	jp z,&movepiece
	cp 45
	jp z,&movepiece
	cp 60
	jp z,&movepiece
	cp 75
	jp z,&movepiece
	cp 90
	jp z,&movepiece
	cp 105
	jp z,&movepiece
	ld a,(selectedb)		;make sure movement is legal
	sub b
	jp z,&movepiece
	ld a,(selectedc)
	sub c
	jp z,&movepiece
	jp &mainloop
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
testkingmovement:
	ld a,(selectedb)		;make sure movement is legal
	sub b
	jr nc,aispositive6
	neg
aispositive6:
	ld d,a
	ld a,(selectedc)
	sub c
	jr nc,aispositive7
	neg
aispositive7:
	add a,d
	cp 7
	jr z,disablecastle
	cp 8
	jr z,disablecastle
	cp 15
	jr z,disablecastle
	ld a,(selectedb)
	sub b
	ld d,a
	ld a,(selectedc)
	add a,d
	cp -9
	jp z,&castleonthebkingside
	cp 23
	jp z,&castleonthebqueenside
	cp 40
	jp z,&castleonthewkingside
	cp 72
	jp z,&castleonthewqueenside
	jp &mainloop

disablecastle:
	ld a,(whosturn)
	or a
	ld a,255
	jr z,disablewhite
disableblack:
	ld (posofbking),a
	jp &movepiece
disablewhite:
	ld (posofwking),a
	jp &movepiece


castleonthewkingside:
	ld a,(posofwking)
	or a
	jp nz,&mainloop
	ld a,(posofwhrook)
	or a
	jp nz,&mainloop
	ld hl,&currentboard
	ld de,62
	add hl,de
	ld d,2
testsquares:
	ld a,(hl)
	cp 9
	jp nc,&mainloop
	dec hl
	dec d
	jr nz,testsquares
	ld a,1
	ld (posofwking),a
	jp &movepiece
movewhiterookkingside:
	ld b,40
	ld c,56
	ld a,255
	ld (posofwking),a
	ld a,0
	ld (colorofspace),a
	ld (selectedcolorofspace),a
	ld (whosturn),a
	ld a,40
	ld (prevpiece),a
	ld (selectedpiece),a
	ld (prevb),a
	ld a,56
	ld (selectedb),a
	ld (prevc),a
	ld (selectedc),a
	ld a,61
	ld (prevpos),a
	inc a
	inc a
	ld (selectedpos),a
	jp &movepiece


castleonthewqueenside:
	ld a,(posofwking)
	or a
	jp nz,&mainloop
	ld a,(posofwarook)
	or a
	jp nz,&mainloop
	ld hl,&currentboard
	ld de,59
	add hl,de
	ld d,3
testsquares1:
	ld a,(hl)
	cp 9
	jp nc,&mainloop
	dec hl
	dec d
	jr nz,testsquares1
	ld a,2
	ld (posofwking),a
	jp &movepiece
movewhiterookqueenside:
	ld b,24
	ld c,56
	ld a,255
	ld (posofwking),a
	ld a,0
	ld (colorofspace),a
	ld (whosturn),a
	ld (selectedb),a
	ld a,8
	ld (selectedcolorofspace),a
	ld a,40
	ld (prevpiece),a
	ld (selectedpiece),a
	ld a,24
	ld (prevb),a
	ld a,56
	ld (prevc),a
	ld (selectedc),a
	ld a,59
	ld (prevpos),a
	ld a,56
	ld (selectedpos),a
	jp &movepiece


castleonthebkingside:
	ld a,(posofbking)
	or a
	jp nz,&mainloop
	ld a,(posofbhrook)
	or a
	jp nz,&mainloop
	ld hl,&currentboard
	ld de,6
	add hl,de
	ld d,2
testsquares2:
	ld a,(hl)
	cp 9
	jp nc,&mainloop
	dec hl
	dec d
	jr nz,testsquares2
	ld a,1
	ld (posofbking),a
	jp &movepiece
moveblackrookkingside:
	ld b,40
	ld c,7
	ld a,255
	ld (posofbking),a
	ld a,8
	ld (colorofspace),a
	ld (selectedcolorofspace),a
	ld a,1
	ld (whosturn),a
	ld a,88
	ld (prevpiece),a
	ld (selectedpiece),a
	ld a,40
	ld (prevb),a
	ld a,56
	ld (selectedb),a
	ld a,7
	ld (prevc),a
	ld (selectedc),a
	ld a,5
	ld (prevpos),a
	inc a
	inc a
	ld (selectedpos),a
	jp &movepiece


castleonthebqueenside:
	ld a,(posofbking)
	or a
	jp nz,&mainloop
	ld a,(posofbarook)
	or a
	jp nz,&mainloop
	ld hl,&currentboard
	ld de,3
	add hl,de
	ld d,3
testsquares3:
	ld a,(hl)
	cp 9
	jp nc,&mainloop
	dec hl
	dec d
	jr nz,testsquares3
	ld a,2
	ld (posofbking),a
	jp &movepiece
moveblackrookqueenside:
	ld b,24
	ld c,7
	ld a,255
	ld (posofbking),a
	ld a,8
	ld (colorofspace),a
	ld a,1
	ld (whosturn),a
	ld a,0
	ld (selectedb),a
	ld (selectedcolorofspace),a
	ld (selectedpos),a
	ld a,7
	ld (prevc),a
	ld (selectedc),a
	ld a,88
	ld (prevpiece),a
	ld (selectedpiece),a
	ld a,24
	ld (prevb),a
	ld a,3
	ld (prevpos),a
	jp &movepiece
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
testforblockingpieces:
	push bc
	ld hl,&currentboard
	ld de,(prevpos)
	add hl,de
	ld (intendedpos),hl
	ld hl,&currentboard
	ld de,(selectedpos)
	add hl,de
	ld a,(selectedb)
	sub b
	jr z,lddewith0
	jr nc,bisnegative
	ld de,1
	jr testc
bisnegative:
	ld de,-1
testc:
	ld a,(selectedc)
	sub c
	jr z,ldbcwith0
	jr nc,cisnegative
	ld bc,8
	jr testsquares6
cisnegative:
	ld bc,-8
testsquares6:
	ex de,hl
	add hl,bc
	ex de,hl
testsquares7:
	add hl,de
	push bc
	ld (TEXT_MEM),hl
	ld a,(TEXT_MEM)
	ld b,a
	ld a,(intendedpos)
	cp b
	pop bc
	jr z,didyoulandonsamecolor
	ld a,(hl)
	cp 9
	jr nc,returnwith1
	jr testsquares7
didyoulandonsamecolor:
	ld a,(whosturn)
	or a
	jr z,areyoulandingonblack
	ld a,(hl)
	cp 9
	jr c,returnwith01
	cp 57
	jr c,returnwith0
	jr returnwith1
areyoulandingonblack:
	ld a,(hl)
	cp 9
	jr c,returnwith01
	cp 57
	jr c,returnwith1
returnwith0:
	ld a,(selectedpiece)
	cp 16
	jr z,returnwith1
	cp 64
	jr z,returnwith1
returnwith01:
	ld a,0
	pop bc
	ret
returnwith1:
	ld a,1
	pop bc
	ret

lddewith0:
	ld de,0
	jr testc
ldbcwith0:
	ld bc,0
	jr testsquares6
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
delay:
	push de
	ld e,200
delay1:
	ld d,255
delay2:
	dec d
	jr nz,delay2
	dec e
	jr nz,delay1
	pop de
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
PutSprite2:
	push bc
        ld a,63
        sub c
        ld c,a
        push hl
        call FIND_PIXEL
        ld de,$FC00
        add hl,de
        ex de,hl
        pop hl
	ld b,8
        ld c,8
        push hl
        pop ix
        ex de,hl
PS_NewRow2:
        push bc
        ld d,(ix)
        inc ix
        push af
        push hl
PS_NewCol2:
        rl d
        ld e,a
        jr nc,PS_NextPixel2
        or (hl)
        ld (hl),a
        jr PS_NextPixel2
PS_NextPixel2:
        ld a,e
        rrca
        jr nc,PS_SameByte2
        inc hl
PS_SameByte2:
        djnz PS_NewCol2
        pop hl
        pop af
        ld de,16
        add hl,de
        pop bc
        dec c
        jr nz,PS_NewRow2
	pop bc
        ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
PutSprite:
	push bc
	push de
	push hl
        ld a,63
        sub c
        ld c,a
        push hl
        call FIND_PIXEL
        ld de,$FC00
        add hl,de
        ex de,hl
        pop hl
	ld b,8
        ld c,8
        push hl
        pop ix
        ex de,hl
PS_NewRow:
        push bc
        ld d,(ix)
        inc ix
        push af
        push hl
PS_NewCol:
        rl d
        ld e,a
        jr nc,PS_NoPixel
        or (hl)
        ld (hl),a
        jr PS_NextPixel
PS_NoPixel:
        cpl
        and (hl)
        ld (hl),a
PS_NextPixel:
        ld a,e
        rrca
        jr nc,PS_SameByte
        inc hl
PS_SameByte:
        djnz PS_NewCol
        pop hl
        pop af
        ld de,16
        add hl,de
        pop bc
        dec c
        jr nz,PS_NewRow
	pop hl
	pop de
	pop bc
        ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Puts text on the screen
;Got the idea for this from some of Patrick Davidson's source,
;   so give him credit
;hl points to address
;b is the # of zero-terminated strings to to put
;check out the text file to find out how this works and
;  how to work it in usgard so you can save lots of bytes!
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
puttext:
	ld a,(hl)
	ld (CURSOR_X),a
	inc hl
	ld a,(hl)
	ld (CURSOR_Y),a
	inc hl
	call D_ZM_STR
	djnz puttext
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
saveboard:
	push bc
	ld de,&savedwhosturn
	ld a,(whosturn)
	ld (de),a
	inc de
	ld hl,&currentboard
	ld bc,64
	ldir
	pop bc
	ld hl,&saved
	ld b,1
	call &puttext
	call OTH_PAUSE
	call &eraseinstructions
	jp &mainloop
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
eraseinstructions:
	ld hl,$FC15
	ld e,5
eraseinstructions1:
	ld d,11
eraseinstructions2:
	ld (hl),%00000000
	inc hl
	dec d
	jr nz,eraseinstructions2
	push de
	ld de,$0005
	add hl,de
	pop de
	dec e
	jr nz,eraseinstructions1
	ret
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
selected:
	.db 0,0,"selected:",0
promotion:
	.db 41,0,"Press first letter of piece.",0
saved:
	.db 41,0,"Saved.",0
openingchess:
	.db 38,12,"OPENING CHESS",0
bypm:
	.db 26,18,"by Patrick McLaughlin",0
email:
	.db 24,24,"pcmprog@hotmail.com",0
second:
	.db 25,30,"2nd-selects/deselects",0
f1:
	.db 39,36,"F1-loads game",0
more:
	.db 33,42,"More-saves game",0
exit:
	.db 46,48,"Exit-exits",0
version:
	.db 110,58,"v0.5b",0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
startboard:
	.db 88,72,80,96,104,80,72,88
	.db 64,64,64,64,64,64,64,64
	.db 0,8,0,8,0,8,0,8
	.db 8,0,8,0,8,0,8,0
	.db 0,8,0,8,0,8,0,8
	.db 8,0,8,0,8,0,8,0
	.db 16,16,16,16,16,16,16,16
	.db 40,24,32,48,56,32,24,40

currentboard:
	.db 88,72,80,96,104,80,72,88
	.db 64,64,64,64,64,64,64,64
	.db 0,8,0,8,0,8,0,8
	.db 8,0,8,0,8,0,8,0
	.db 0,8,0,8,0,8,0,8
	.db 8,0,8,0,8,0,8,0
	.db 16,16,16,16,16,16,16,16
	.db 40,24,32,48,56,32,24,40

savedwhosturn:
	.db 0

savedboard:
	.db 88,72,80,96,104,80,72,88
	.db 64,64,64,64,64,64,64,64
	.db 0,8,0,8,0,8,0,8
	.db 8,0,8,0,8,0,8,0
	.db 0,8,0,8,0,8,0,8
	.db 8,0,8,0,8,0,8,0
	.db 16,16,16,16,16,16,16,16
	.db 40,24,32,48,56,32,24,40
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pieces:
wspace:
	.db %11111111
	.db %10000000
	.db %10000000
	.db %10000000
	.db %10000000
	.db %10000000
	.db %10000000
	.db %11111111

bspace:
	.db %11111111
	.db %11010101
	.db %10101010
	.db %11010101
	.db %10101010
	.db %11010101
	.db %10101010
	.db %11111111

wpawn:
	.db %11111111
	.db %10000000
	.db %10001000
	.db %10010100
	.db %10010100
	.db %10001000
	.db %10011100
	.db %11111111

wknight:
	.db %11111111
	.db %10011000
	.db %10110111
	.db %10101010
	.db %10100100
	.db %10010010
	.db %10111110
	.db %11111111

wbishop:
	.db %11111111
	.db %10001000
	.db %10011100
	.db %10010100
	.db %10110110
	.db %10011100
	.db %10111110
	.db %11111111

wrook:
	.db %11111111
	.db %10101010
	.db %10111110
	.db %10010100
	.db %10010100
	.db %10010100
	.db %10111110
	.db %11111111

wqueen:
	.db %11111111
	.db %10001000
	.db %10110110
	.db %10100010
	.db %10010100
	.db %10011100
	.db %10111110
	.db %11111111

wking:
	.db %11111111
	.db %10011100
	.db %10101010
	.db %10111110
	.db %10101010
	.db %10010100
	.db %10111110
	.db %11111111

bpawn:
	.db %11111111
	.db %10000000
	.db %10001000
	.db %10011100
	.db %10011100
	.db %10001000
	.db %10011100
	.db %11111111

bknight:
	.db %11111111
	.db %10011000
	.db %10110111
	.db %10111110
	.db %10111100
	.db %10011110
	.db %10111110
	.db %11111111

bbishop:
	.db %11111111
	.db %10001000
	.db %10011100
	.db %10011100
	.db %10111110
	.db %10011100
	.db %10111110
	.db %11111111

brook:
	.db %11111111
	.db %10101010
	.db %10111110
	.db %10011100
	.db %10011100
	.db %10011100
	.db %10111110
	.db %11111111

bqueen:
	.db %11111111
	.db %10001000
	.db %10111110
	.db %10101010
	.db %10010100
	.db %10011100
	.db %10111110
	.db %11111111

bking:
	.db %11111111
	.db %10011100
	.db %10101010
	.db %10111110
	.db %10101010
	.db %10011100
	.db %10111110
	.db %11111111

cursor:
	.db %11111111
	.db %11000001
	.db %10000000
	.db %10000000
	.db %10000000
	.db %10000000
	.db %11000001
	.db %11111111
.end





